/*
 * Created on Jan 4, 2012
 *
 */
package charlesgunn.anim.core;

import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.MethodDescriptor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.omg.CORBA.portable.InvokeHandler;


public class AnimatedThing extends AnimatedAdaptor {

	transient Settable tic;
	transient boolean hasStart, hasStop;
	transient Method startM, stopM;
	transient BeanInfo info;

	public AnimatedThing(Settable tic) {
		this(tic, "Settable thing");
	}
		public AnimatedThing(Settable tic, String name) {
			this.tic = tic;
			try {
				info = Introspector.getBeanInfo( tic.getClass() );
			} catch (IntrospectionException e) {
				e.printStackTrace();
			}
			MethodDescriptor[] methods = info.getMethodDescriptors();
			for (MethodDescriptor m : methods)	{
//				System.err.println("method name:"+m.getName());
				if (m.getName().equals("startAnimation")) {
					hasStart = true; startM = m.getMethod();
				}
				if (m.getName().equals("stopAnimation")) {
					hasStop = true; stopM = m.getMethod();
				}

			}
		}
		
		@Override
		public String getName() {
			return "Settable thing";
		}
		
		@Override
		public void setValueAtTime(double t) {
			tic.setValueAtTime(t);
//			System.err.println("updating "+t);
		}
		@Override
		public void endAnimation() {
			if (hasStop)	{
				try {
					stopM.invoke(tic, null);
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

		@Override
		public void startAnimation() {
			if (hasStart)	{
				try {
					startM.invoke(tic, null);
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}


}
