package charlesgunn.anim.core;

/**
 * A key/value pair, where the key is of type {@link TimeDescriptor} and the
 * value is the type T.
 * @author Charles Gunn
 *
 * @param <T>
 */
public class KeyFrame<T> {

	TimeDescriptor td;
	T value;
//	public KeyFrame(TimeDescriptor td)	{
//		this(td, null);
//	}
//	public KeyFrame(double t )	{
//		this(new TimeDescriptor(t));
//	}
	
	public KeyFrame()	{
		this(new TimeDescriptor(0), null);
	}
	public KeyFrame(TimeDescriptor t, T v)	{
		td = t;
		value = v;
	}
	
	public TimeDescriptor getTimeDescriptor()	{
		return td;
	}
	
	public double getTime()	{
		return td.getTime();
	}
	
	public void setTime(double t)	{
		td.setTime(t);
	}
	
	public T getValue()	{
		return value;
	}
	
	public void setValue(T v)	{
		value = v;
	}
}
