package charlesgunn.anim.core;

/**
 * A class that basically represents a time value as a double.
 * It's wrapped in this class primarily to allow for editing the
 * time value and having many instance of {@link KeyFrame} automatically be reset
 * to the edited time (since they all share the same instance of TimeDescriptor).
 * 
 * @author Charles Gunn
 *
 */
public class TimeDescriptor {
	double time;
	transient long lastModified;

	public TimeDescriptor() {
		this(0);
	}
	
	public TimeDescriptor(double currentTime) {
		setTime(currentTime);
//		System.err.println("Allocating new td");
	}

	public void setTime(Double t)	{
		setTime(t, System.currentTimeMillis());
	}
	
	public void setTime(Double t, long timestamp)	{
		time = t;
		lastModified = timestamp;
	}
	
	public double getTime()	{
		return time;
	}
}
