package charlesgunn.anim.gui;

import charlesgunn.anim.core.KeyFrame;
import charlesgunn.anim.core.TimeDescriptor;

/**
 * This is the event structure the {@link AnimationPanel} uses to communicate with his listeners.
 * 
 * TODO: add more getters/setters to AnimationPanel: now the listeners often use direct access to
 * the fields of AnimationPanel to detect its state.  But we all know this is evil.
 * 
 * @author Charles Gunn
 *
 */
public class AnimationPanelEvent {

	public enum EventType {
		KEY_FRAME_ADDED,
		KEY_FRAME_CHANGED,
		KEY_FRAME_DELETED,
		SET_VALUE_AT_TIME,
		EXPORT,
		IMPORT,
		PLAYBACK_STARTED,
		PLAYBACK_COMPLETED
	}
	public AnimationPanel source;
	public TimeDescriptor time;
	public long timeStamp;
	public EventType type;
	
	public AnimationPanelEvent(EventType foo, AnimationPanel ap, TimeDescriptor td, KeyFrame kf) {
		type = foo;
		source = ap;
		time = td;
		timeStamp = System.currentTimeMillis();
	}
}
