package charlesgunn.anim.io;

import java.util.ArrayList;
import java.util.List;

import charlesgunn.anim.core.KeyFrameAnimated;
import charlesgunn.anim.core.KeyFrameAnimatedDouble;
import charlesgunn.anim.core.KeyFrameAnimatedTransformation;
import charlesgunn.anim.core.TimeDescriptor;

import com.thoughtworks.xstream.XStream;

import de.jreality.math.MatrixBuilder;
import de.jreality.math.Rn;
import de.jreality.scene.Transformation;

public class AnimXStream {

	public static void main(String[] argc)	{
		List<KeyFrameAnimated> animated = new ArrayList<KeyFrameAnimated>();
		TimeDescriptor t0 = new TimeDescriptor(0.0);
		TimeDescriptor t1 = new TimeDescriptor(1.0);
		
		KeyFrameAnimatedDouble ad = new KeyFrameAnimatedDouble(1.0);
		ad.setName("rosamundo");
		ad.setCurrentValue(0.0);
		ad.addKeyFrame(t0);
		ad.setCurrentValue(1.0);
		ad.addKeyFrame(t1);
		animated.add(ad);
		
		Transformation t = new Transformation();
		KeyFrameAnimatedTransformation at = new KeyFrameAnimatedTransformation(t);
		at.setName("darjan");
		MatrixBuilder.euclidean().translate(1,2,3).assignTo(t);
		at.addKeyFrame(t0);
		System.err.println("Matrix is "+Rn.matrixToString(
				at.getKeyFrames().get(0).getValue().getArray()));
		MatrixBuilder.euclidean().scale(1,2,3).assignTo(t);
		at.addKeyFrame(t1);
		animated.add(at);
		
		XStream xstream = ImportExport.setupXStream();
		String xml = xstream.toXML(animated);
		System.err.println("xml = "+xml);
		List<KeyFrameAnimated> ad2 = (List<KeyFrameAnimated>) xstream.fromXML(xml);
		for (KeyFrameAnimated kfa : ad2)	{
			System.err.println("Name = "+kfa.getName());
		}
		xml = xstream.toXML(ad2);
		System.err.println("xml = "+xml);
		
	}
}
