/*
 * Created on May 14, 2008
 *
 */
package charlesgunn.anim.io;

import java.util.List;

import charlesgunn.anim.core.SortedKeyFrameList;
import charlesgunn.anim.gui.AnimationPanel;
import charlesgunn.anim.gui.AnimationPanelListener;

import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

public class AnimationPanelConverter implements Converter {

	public void marshal(Object arg0, HierarchicalStreamWriter writer,
			MarshallingContext context) {
		AnimationPanel ap = (AnimationPanel) arg0;
        writer.startNode("currentTime");
        context.convertAnother(ap.getCurrentTime());
        writer.endNode();
        writer.startNode("keys");
        context.convertAnother(ap.getKeyFrames());
        writer.endNode();
	    writer.startNode("listeners");
	    context.convertAnother(ap.getListeners());
	    writer.endNode();
		
	}

	public Object unmarshal(HierarchicalStreamReader reader,
			UnmarshallingContext context) {
		AnimationPanel ap = new AnimationPanel();
		System.err.println("In apc unmarshal()");
        while (reader.hasMoreChildren()) {
            reader.moveDown();
            if ("keys".equals(reader.getNodeName())) {
                ap.setKeyFrames(
                	(SortedKeyFrameList<Object>)context.convertAnother(null, SortedKeyFrameList.class));
            } else if ("currentTime".equals(reader.getNodeName())) {
                ap.setCurrentTime((Double) context.convertAnother(null, Double.class));
            } else if ("listeners".equals(reader.getNodeName())) {
                ap.setListeners((List<AnimationPanelListener>) context.convertAnother(null, List.class));
            }
            reader.moveUp();
        }			
        return ap;
	}

	public boolean canConvert(Class arg0) {
		return arg0 == AnimationPanel.class;
	}

}
