package charlesgunn.anim.io;

import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

import de.jreality.math.FactoredMatrix;

public class FactoredMatrixConverter extends Object implements
		Converter {

	public void marshal(Object object, HierarchicalStreamWriter writer,
			MarshallingContext context) {
		FactoredMatrix fm = (FactoredMatrix) object;
	    context.convertAnother( (double[])fm.getArray());
	}

	public Object unmarshal(HierarchicalStreamReader reader,
			UnmarshallingContext context) {
	    double[] data = (double[]) context.convertAnother(null, double[].class);
	    FactoredMatrix fm = new FactoredMatrix(data);
	    fm.update();
		return fm;
	}

	public boolean canConvert(Class arg0) {
		return arg0 == FactoredMatrix.class;
	}

}
