/*
 * Created on May 14, 2008
 *
 */
package charlesgunn.anim.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Date;
import java.util.List;

import charlesgunn.anim.core.KeyFrame;
import charlesgunn.anim.core.KeyFrameAnimated;
import charlesgunn.anim.core.KeyFrameAnimatedBean;
import charlesgunn.anim.core.KeyFrameAnimatedColor;
import charlesgunn.anim.core.KeyFrameAnimatedDouble;
import charlesgunn.anim.core.KeyFrameAnimatedTransformation;
import charlesgunn.anim.core.SimpleKeyFrameAnimated;
import charlesgunn.anim.core.TimeDescriptor;
import charlesgunn.anim.gui.AnimationPanel;
import charlesgunn.anim.jreality.SceneGraphAnimator;

import com.thoughtworks.xstream.XStream;

import de.jreality.math.FactoredMatrix;

public class ImportExport {

	// these are the two objects which will be written into the file
	Date timestamp = new Date();
	AnimationPanel animationPanel;
	
	public void write(AnimationPanel ap, File output)	{
		animationPanel = ap;
		// first set up
		XStream xstream = setupXStream();
//		for (AnimationPanelListener apl : ap.getListeners())
//			animated.add(apl);
		
		OutputStream os = null;
		try {
			os = new FileOutputStream(output);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		xstream.toXML(this, os );
		
	}

	public static void readInto(AnimationPanel ap, InputStream is)	{
		// first set up
		XStream xstream = setupXStream();
		ImportExport foo = (ImportExport) xstream.fromXML(is);
		System.err.println("Date = "+foo.timestamp);
		AnimationPanel readP = foo.animationPanel;
		ap.setFromArchive(readP);
	}
	
	public static void readInto(AnimationPanel ap, File input)	{

		InputStream is = null;
		try {
			is = new FileInputStream(input);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		readInto(ap, is);
	}
	
	public static KeyFrameAnimated elementNamed(String name, List<KeyFrameAnimated> list)	{
		for (KeyFrameAnimated kfa :  list)	{
			if (kfa.getName().equals(name)) return kfa;
		}
		return null;
	}

	public static XStream setupXStream() {
		XStream xstream = new XStream();
		xstream.alias("KeyFrameAnimatedColor", KeyFrameAnimatedColor.class);
		xstream.alias("KeyFrameAnimatedBean", KeyFrameAnimatedBean.class);
		xstream.alias("KeyFrameAnimatedDouble", KeyFrameAnimatedDouble.class);
		xstream.alias("KeyFrameAnimatedTransformation", KeyFrameAnimatedTransformation.class);
		xstream.alias("SceneGraphAnimator", SceneGraphAnimator.class);
		xstream.alias("TimeDescriptor", TimeDescriptor.class);
		xstream.alias("KeyFrame", KeyFrame.class);
		xstream.alias("AbstractKeyFrameAnimated", SimpleKeyFrameAnimated.class);
		xstream.alias("FactoredMatrix", FactoredMatrix.class);
		xstream.registerConverter(new FactoredMatrixConverter());
		xstream.registerConverter(new KeyFrameAnimatedBeanConverter());
		return xstream;
	}
	
}
