/*
 * Created on May 19, 2008
 *
 */
package charlesgunn.anim.io;

import java.util.List;
import java.util.Vector;

import charlesgunn.anim.core.KeyFrameAnimated;
import charlesgunn.anim.core.KeyFrameAnimatedBean;

import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

public class KeyFrameAnimatedBeanConverter implements Converter {

	public void marshal(Object arg0, HierarchicalStreamWriter writer,
			MarshallingContext context) {
		KeyFrameAnimatedBean kfab = (KeyFrameAnimatedBean) arg0;
		List<String> excluded = new Vector<String>();
		List<KeyFrameAnimated> animatedFields = new Vector<KeyFrameAnimated>();
        writer.startNode("name");
        context.convertAnother(kfab.getName());
        writer.endNode();
        writer.startNode("excluded");
        context.convertAnother(kfab.getExcluded());
        writer.endNode();
        writer.startNode("animatedFields");
        context.convertAnother(kfab.getAnimatedFields());
        writer.endNode();
		
	}

	public Object unmarshal(HierarchicalStreamReader reader,
			UnmarshallingContext context) {
		KeyFrameAnimatedBean kfab = new KeyFrameAnimatedBean(null);
		System.err.println("In kfab unmarshal()");
        while (reader.hasMoreChildren()) {
            reader.moveDown();
            if ("name".equals(reader.getNodeName())) {
                kfab.setName(
                	(String)context.convertAnother(null, String.class));
            } else if ("excluded".equals(reader.getNodeName())) {
                kfab.setExcluded((List)context.convertAnother(null, List.class));
            } else if ("animatedFields".equals(reader.getNodeName())) {
                kfab.setAnimatedFields((List) context.convertAnother(null, List.class));
            }
            reader.moveUp();
        }			
        return kfab;
	}

	public boolean canConvert(Class arg0) {
		return arg0 == KeyFrameAnimatedBean.class;
	}

}
