package charlesgunn.anim.sets;

import java.awt.geom.Rectangle2D;

import charlesgunn.anim.util.AnimationUtility;

public class AnimatedRectangle2DSet extends AbstractAnimatedSet {

	Rectangle2D[][] valueSet;
	public AnimatedRectangle2DSet(double[][] dkeySet, Rectangle2D[][] valueSet)	{
		this(dkeySet, valueSet, null);
	}
	public AnimatedRectangle2DSet(double[][] dkeySet, Rectangle2D[][] valueSet, AnimationUtility.InterpolationTypes[] interpType)	{
		super(dkeySet, interpType);
		this.valueSet = valueSet;
	}
	
	
	public double getTMin()	{
		return keySet[0][0];
	}
	
	public double getTMax()	{
		return keySet[0][keySet[0].length-1];
	}
	
	public Rectangle2D[] getValuesAtTime(double t, Rectangle2D[] vals)	{
		if (vals == null || vals.length != valueSet.length) vals = new Rectangle2D[valueSet.length];
		for (int j = 0; j<keySet.length; ++j)	{
			int key = -1;
			int n = keySet[j].length;
			if (wrapType[j] == AnimationUtility.BoundaryModes.REPEAT) t = getTMin()+ (t % (getTMax()-getTMin()));
			for (int i = 1; i<n; ++i)	{
				if (t < keySet[j][i]) { key = i-1; break;}
			} 			
			if (key == -1)  {
				vals[j] = valueSet[j][n-1];
				continue;
			}
			switch(interpType[j])	{
			case CONSTANT:
			default:
				vals[j] = valueSet[j][key];
				break;
			case  LINEAR:
				vals[j] = AnimationUtility.linearInterpolation(t, keySet[j][key], keySet[j][key+1], valueSet[j][key], valueSet[j][key+1]);
				break;
			case  CUBIC_HERMITE:
				vals[j] = AnimationUtility.hermiteInterpolation(t, keySet[j][key], keySet[j][key+1], valueSet[j][key], valueSet[j][key+1]);
				break;
			}
		}
		return vals;
	}

}
