package charlesgunn.anim.sets;

import java.awt.geom.Rectangle2D;

import charlesgunn.anim.core.FramedCurve;
import charlesgunn.anim.util.AnimationUtility;
import de.jreality.geometry.IndexedFaceSetUtility;
import de.jreality.math.FactoredMatrix;
import de.jreality.math.Matrix;
import de.jreality.math.MatrixBuilder;
import de.jreality.scene.Appearance;
import de.jreality.scene.SceneGraphComponent;
import de.jreality.scene.data.AttributeEntityUtility;
import de.jreality.shader.CommonAttributes;
import de.jreality.shader.Texture2D;
import de.jreality.util.SceneGraphUtility;

public class AnimatedScreen {

		FramedCurve framedCurve;
		AnimatedRectangle2DSet animRect;
		Rectangle2D[] rlist = {new Rectangle2D.Double()};
		AnimatedDoubleOld transparency;
		Texture2D tex2d;
		SceneGraphComponent theComp;
		static double[][] verts = {{0,0,0},{1,0,0},{1,1,0},{0,1,0}};
		public AnimatedScreen(FramedCurve fc, AnimatedRectangle2DSet ar, AnimatedDoubleOld t, double aspectRatio)	{
			super();
			framedCurve = fc;
			animRect = ar;
			transparency = t;
			theComp = SceneGraphUtility.createFullSceneGraphComponent("animatedScreen");
			SceneGraphComponent screenSGC = new SceneGraphComponent();
			MatrixBuilder.euclidean().scale(aspectRatio,1.0,1.0).assignTo(screenSGC);
			screenSGC.setGeometry(IndexedFaceSetUtility.constructPolygon(verts));
			theComp.addChild(screenSGC);
			Appearance ap = theComp.getAppearance();
			tex2d = (Texture2D) AttributeEntityUtility
		       .createAttributeEntity(Texture2D.class, "polygonShader.texture2d", ap, true);		
		}
		
		public Texture2D getTexture2D() {
			return tex2d;
		}
		
		public SceneGraphComponent getValueAtTime(double t)	{
			FactoredMatrix fm = framedCurve.getValueAtTime(t);
			theComp.getTransformation().setMatrix(fm.getArray());
			double tr = transparency.getValueAtTime(t);
			theComp.getAppearance().setAttribute(CommonAttributes.TRANSPARENCY, tr);
			animRect.getValuesAtTime(t, rlist);
			double[] tm = AnimationUtility.matrixFromRectangle(null, rlist[0]);
			tex2d.setTextureMatrix(new Matrix(tm));
			return theComp;
		}
}
